import { defineComponent, $prefix, props, setup } from '@opentinyvue/vue-common';
import { renderless, api } from '@opentinyvue/vue-renderless/loading/vue';
import '@opentinyvue/vue-theme/loading/index.css';
import { iconLoadingShadow } from '@opentinyvue/vue-icon';

function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  var hook;
  if (injectStyles) {
    hook = injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

var __vue2_script = defineComponent({
  inheritAttrs: false,
  name: $prefix + "Loading",
  emits: ["after-leave"],
  props: [].concat(props, ["_constants", "loadingImg", "size"]),
  components: {
    TinyIconLoadingShadow: iconLoadingShadow()
  },
  setup: function setup$1(props2, context) {
    return setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("transition", {
    attrs: {
      "name": "tiny-loading-fade"
    },
    on: {
      "after-leave": _vm.handleAfterLeave
    }
  }, [_c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.visible,
      expression: "state.visible"
    }],
    staticClass: "tiny-loading tiny-loading__mask",
    class: [_vm.state.customClass, {
      "is-fullscreen": _vm.state.fullscreen
    }],
    style: {
      backgroundColor: _vm.state.background || ""
    },
    attrs: {
      "data-tag": "tiny-loading"
    }
  }, [_c("div", {
    class: ["tiny-loading__spinner", {
      small: "tiny-loading__spinner-small",
      medium: "tiny-loading__spinner-medium",
      large: "tiny-loading__spinner-large"
    }[_vm.size]]
  }, [_vm.state.spinner ? _c(_vm.state.spinner, {
    tag: "component",
    staticClass: "tiny-icon-loading"
  }) : _vm.state.loadingImg ? _c("img", {
    staticClass: "circular",
    style: _vm.state.iconStyle,
    attrs: {
      "src": _vm.state.loadingImg
    }
  }) : _c("tiny-icon-loading-shadow", {
    staticClass: "circular"
  }), _vm.state.text ? _c("p", {
    staticClass: "tiny-loading__text"
  }, [_vm._v(_vm._s(_vm.state.text))]) : _vm._e()], 1)])]);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var pc = /* @__PURE__ */ function() {
  return __component__.exports;
}();

export { pc as default };
